#include <stdio.h>

#define FAST_CRC16
//#define SLOW_CRC16
extern unsigned short __checksum;

extern unsigned short slow_crc16(unsigned short,unsigned char *,unsigned short);
extern unsigned short fast_crc16(unsigned short,unsigned char *,unsigned short);

const int zero=0;


void main(void)
{
     unsigned short sum=0;

#ifdef SLOW_CRC16
     sum = slow_crc16(sum,(unsigned char *)0x1100, 0xFFDD-0x1100+1);
     sum = slow_crc16(sum,(unsigned char *)0xFFFE, 2);
     sum = slow_crc16(sum,(unsigned char *)&zero,2);
#elif defined FAST_CRC16
     sum = fast_crc16(sum,(unsigned char *)0x1100, 0xFFDD-0x1100+1);
     sum = fast_crc16(sum,(unsigned char *)0xFFFE, 2);
#endif

     if(sum!=__checksum)
          printf("***Checksum failed: %hx instead of %hx!***\n",sum, __checksum);
     else
          printf("***Checksum is correct!***\n");
}
